* GUT, J.A.W. Programao Matemtica para Otimizao de Processos. EDUSP 2021.
* https://sites.usp.br/otimizacao/
***** Problema de programao de produo *****************
***** Conjuntos *******************************************
SET i ordens   / 1*5 / ;
SET j unidades / 1*2 / ;
ALIAS (i,ii);
SET PS(i,ii) sequncias proibidas / 1.3, 1.5, 2.1, 3.4, 4.2,
4.5, 1.1, 2.2, 3.3, 4.4, 5.5  /  ;
SET AS(i,j) atribuies proibidas / 4.1, 3.2 /  ;
***** Definio de parmetros *****************************
TABLE tempo(i,j) tempo de processamento (dias)
      1      2
1   6.8    6.1
2   7.0    7.0
3   5.0      0
4     0    5.1
5   4.9    5.6 ;
TABLE s(i,ii) tempo de setup para i->ii (dias)
     1     2     3     4     5
1    0     0     0     0     0
2    0     0   1.1     0   0.7
3  1.0   0.2     0     0     0
4    0     0     0     0     0
5  1.4     0     0   0.3     0   ;
PARAMETER d(i) prazo para entrega da ordem i (dias)
/ 1   14
  2   14
  3   21
  4   14
  5   21 / ;
PARAMETER p(i) peso da ordem i
/ 1  1
  2  1
  3  1
  4  2
  5  1  / ;
PARAMETER ro(i) data liberao ordem i (dias)
/ 1    0
  2  5.0
  3    0
  4  6.0
  5    0  / ;
PARAMETER ru(j) data liberao unidade j (dias)
/ 1    0
  2  3.0 / ;
SCALAR M BigM ;
M = 50 ;
***** Declarao de variveis *****************************
VARIABLES
AT      objetivo atraso total ;
POSITIVE VARIABLES
x(i)    instante de concluso ordem i ,
T(i)    atraso ordem i ;
BINARY VARIABLES
wf(i,j) ordem i  primeira na unidade j ,
w(i,j)  ordem i na unidade j mas no primeira ,
y(i,ii) sequncia de ordens i->i ;
***** Declarao de equaes ******************************
EQUATIONS
h0         Objetivo atraso total ,
h1(i,ii)   Sequncias proibidas ,
h2(i,j)    Alocaes proibidas ,
h3(i)      Cada ordem i deve ser processada uma vez ,
h4(ii)     Cada ordem est no incio ou adiante em uma fila ,
g1(j,i,ii) Cada sequncia deve estar na mesma unidade ,
g2(j)      Cada unidade tem no mximo uma ordem inicial ,
g3(i)      Cada ordem est no fim ou antes em uma fila ,
g4(i,ii)   Ordem s pode ser processada aps concluso da anterior ,
g5(i)      Respeitar liberaes e tempos de processamento ,
g6(i)      Atraso ordem i ;
***** Equaes ********************************************
h0..       AT - SUM(i,p(i)*T(i)) =E= 0 ;
h1(PS(i,ii)).. y(i,ii) =E= 0 ;
h2(AS(i,j)).. wf(i,j) + w(i,j) =E= 0;
h3(i)..    SUM(j, wf(i,j) +  w(i,j)) -1 =E= 0 ;
h4(i)..    SUM(j, wf(i,j)) + SUM(ii,y(ii,i)) -1 =E= 0 ;
g1(j,i,ii).. wf(i,j) + w(i,j) - w(ii,j) + y(i,ii) -1 =L= 0 ;
g2(j)..    SUM(i, wf(i,j)) -1 =L= 0 ;
g3(i)..    SUM(ii,y(i,ii)) -1 =L= 0 ;
g4(i,ii).. x(i) - x(ii) + SUM(j,(s(i,ii)+tempo(ii,j))*w(ii,j)) + M*(y(i,ii) -1) =L= 0 ;
g5(i)..    SUM(j,(MAX(ro(i),ru(j))+tempo(i,j))*(wf(i,j)+w(i,j))) - x(i) =L= 0 ;
g6(i)..    x(i) - d(i) - T(i) =L= 0 ;
***** Soluo do problema *********************************
MODEL problema /all/ ;
SOLVE problema USING MIP MINIMAZING AT;
***********************************************************
